stages:
  - build

variables:
  NODE_ENV: "production"
  ARTIFACT_FOLDER_NAME: "artifact-$CI_COMMIT_SHORT_SHA"  # Define the artifact folder name

before_script:
  - 'if ! command -v nvm &> /dev/null; then curl -o- https://raw.githubusercontent.com/nvm-sh/nvm/v0.39.1/install.sh | bash; fi'
  - 'export NVM_DIR="$HOME/.nvm"'
  - '[ -s "$NVM_DIR/nvm.sh" ] && \. "$NVM_DIR/nvm.sh"'
  - 'if ! command -v node &> /dev/null || [ $(node -v | cut -d "." -f1 | cut -d "v" -f2) -lt 20 ]; then nvm install 20; nvm use 20; fi'
  - 'if ! command -v npm &> /dev/null; then npm install -g npm@latest; fi'
  - echo "npm version $(npm -v)"
  - echo "Node version $(node -v)"

build:
  stage: build
  script:
    - rm -rf node_modules
    - npm install
    - npm run build
    - mkdir -p public
    - mkdir -p $ARTIFACT_FOLDER_NAME
    - cp -r ./out/* public  # Copy the built assets to the public directory
    - cp -r ./out/* $ARTIFACT_FOLDER_NAME  # Copy the entire .next directory to the specified artifact folder
    - echo $CI_COMMIT_SHORT_SHA > public/commit.txt  # Save the commit SHA to a file in the public directory
    - echo $CI_COMMIT_SHORT_SHA > $ARTIFACT_FOLDER_NAME/commit.txt  # Save the commit SHA to a file in the artifact directory
  artifacts:
    expire_in: 1 week  # Set expiration for artifacts
    name: "$ARTIFACT_FOLDER_NAME"  # Name the artifact folder with the specified name
    paths:
      - public/
      - $ARTIFACT_FOLDER_NAME/
  only:
    - main  # Only run this job for the master branch
